<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>LDAP Rule Check</title>
</head>
<body>
<p>This rule ensures that methods in the <code>MiddleWareImpl</code> class properly use LDAP-related variables and operations. It checks for the presence of <code>InitialDirContext</code> or <code>DirContext</code> creation and LDAP search operations to ensure correct LDAP authentication implementation.</p>

<h2>Noncompliant Code Example</h2>
<pre>
package com.example;

import java.util.HashMap;
import java.util.Map;

public class MiddleWareImpl {
  public boolean authenticateUser(String username, String password) {
    // Using a simple in-memory map for user authentication
    Map&lt;String, String&gt; users = new HashMap&lt;&gt;();
    users.put(&quot;user1&quot;, &quot;password1&quot;);
    users.put(&quot;user2&quot;, &quot;password2&quot;);

    // Noncompliant
    return users.containsKey(username) &amp;&amp; users.get(username).equals(password);
  }
}
</pre>

<h2>Compliant Solution</h2>
<pre>
package com.attijari.middleware.service;

import javax.naming.NamingEnumeration;
import javax.naming.NamingException;
import javax.naming.directory.DirContext;
import javax.naming.directory.InitialDirContext;
import javax.naming.directory.SearchControls;
import javax.naming.directory.SearchResult;
import java.util.Properties;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class MiddleWareImpl {

    private static final Logger log = LoggerFactory.getLogger(MiddleWareImpl.class);

    @Value(&quot;${java.naming.factory.initial}&quot;)
    String ldapCtxFactory;

    @Value(&quot;${java.naming.security.authentication}&quot;)
    String ldapAuthentication;

    @Value(&quot;${java.naming.referral}&quot;)
    String ldapReferral;

    @Value(&quot;${java.naming.provider.url}&quot;)
    String ldapUrl;

    @Value(&quot;${java.naming.security.principal}&quot;)
    String ldapPrincipal;

    @Transactional
    public UserAD authenticateUser(String username, String password) {
        log.debug(&quot;Request to login to AD with {}&quot;, username);
        return checkLogin(username, password);
    }

    private UserAD checkLogin(String username, String password) {
        Properties properties = new Properties();
        properties.put(&quot;java.naming.factory.initial&quot;, ldapCtxFactory);
        properties.put(&quot;java.naming.security.authentication&quot;, ldapAuthentication);
        properties.put(&quot;java.naming.referral&quot;, ldapReferral);
        properties.put(&quot;java.naming.provider.url&quot;, ldapUrl);
        properties.put(&quot;java.naming.security.principal&quot;, ldapPrincipal + username);
        properties.put(&quot;java.naming.security.credentials&quot;, password);

        try {
            DirContext ctx = new InitialDirContext(properties); // Compliant
            SearchControls ctls = new SearchControls(2, 0L, 0, UserAD.requestedAttributes, false, false);
            NamingEnumeration&lt;SearchResult&gt; answerSearch = ctx.search(
                &quot;dc=bank-sud,dc=tn&quot;,
                &quot;(&amp;(objectCategory=person)(objectClass=user)(sAMAccountName=&quot; + username + &quot;))&quot;,
                ctls
            ); // Compliant

            if (answerSearch.hasMore()) {
                return new UserAD(answerSearch.next().getAttributes());
            } else {
                return null;
            }
        } catch (NamingException e) {
            log.error(e.getMessage());
            return null;
        }
    }
}
</pre>
</body>
</html>
